diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/EcKeyParams.idl webkitgtk-2.48.0/Source/WebCore/crypto/parameters/EcKeyParams.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/EcKeyParams.idl	2025-02-25 02:25:41.003382200 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/parameters/EcKeyParams.idl	2025-04-04 16:34:42.731469905 -0500
@@ -27,6 +27,7 @@
 // https://www.w3.org/TR/WebCryptoAPI/#EcKeyImportParams-dictionary, and
 // https://www.w3.org/TR/WebCryptoAPI/#EcKeyGenParams-dictionary
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmEcKeyParams
 ] dictionary EcKeyParams : CryptoAlgorithmParameters {
     required DOMString namedCurve;
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/HkdfParams.idl webkitgtk-2.48.0/Source/WebCore/crypto/parameters/HkdfParams.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/HkdfParams.idl	2025-02-25 02:25:41.003382200 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/parameters/HkdfParams.idl	2025-04-04 16:34:42.731647732 -0500
@@ -26,6 +26,7 @@
 typedef (object or DOMString) HashAlgorithmIdentifier;
 
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmHkdfParams,
 ] dictionary HkdfParams : CryptoAlgorithmParameters {
     // The algorithm to use with HMAC (e.g.: SHA-256)
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/HmacKeyParams.idl webkitgtk-2.48.0/Source/WebCore/crypto/parameters/HmacKeyParams.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/HmacKeyParams.idl	2025-02-25 02:25:41.003382200 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/parameters/HmacKeyParams.idl	2025-04-04 16:34:42.731810991 -0500
@@ -29,6 +29,7 @@ typedef (object or DOMString) HashAlgori
 // https://www.w3.org/TR/WebCryptoAPI/#hmac-importparams, and
 // https://www.w3.org/TR/WebCryptoAPI/#hmac-keygen-params
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmHmacKeyParams
 ] dictionary HmacKeyParams : CryptoAlgorithmParameters {
     // The inner hash function to use.
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/Pbkdf2Params.idl webkitgtk-2.48.0/Source/WebCore/crypto/parameters/Pbkdf2Params.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/Pbkdf2Params.idl	2025-02-25 02:25:41.003382200 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/parameters/Pbkdf2Params.idl	2025-04-04 16:34:42.732008946 -0500
@@ -26,6 +26,7 @@
 typedef (object or DOMString) HashAlgorithmIdentifier;
 
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmPbkdf2Params,
 ] dictionary Pbkdf2Params : CryptoAlgorithmParameters {
     required BufferSource salt;
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/RsaHashedImportParams.idl webkitgtk-2.48.0/Source/WebCore/crypto/parameters/RsaHashedImportParams.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/RsaHashedImportParams.idl	2025-02-25 02:25:41.003382200 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/parameters/RsaHashedImportParams.idl	2025-04-04 16:34:42.732166384 -0500
@@ -26,6 +26,7 @@
 typedef (object or DOMString) HashAlgorithmIdentifier;
 
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmRsaHashedImportParams
 ] dictionary RsaHashedImportParams : CryptoAlgorithmParameters {
     // The hash algorithm to use
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/RsaHashedKeyGenParams.idl webkitgtk-2.48.0/Source/WebCore/crypto/parameters/RsaHashedKeyGenParams.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/RsaHashedKeyGenParams.idl	2025-02-25 02:25:41.003382200 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/parameters/RsaHashedKeyGenParams.idl	2025-04-04 16:34:42.732345743 -0500
@@ -26,6 +26,7 @@
 typedef (object or DOMString) HashAlgorithmIdentifier;
 
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmRsaHashedKeyGenParams
 ] dictionary RsaHashedKeyGenParams : RsaKeyGenParams {
     // The hash algorithm to use
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/RsaKeyGenParams.idl webkitgtk-2.48.0/Source/WebCore/crypto/parameters/RsaKeyGenParams.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/RsaKeyGenParams.idl	2025-02-25 02:25:41.003382200 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/parameters/RsaKeyGenParams.idl	2025-04-04 16:34:42.732500877 -0500
@@ -24,6 +24,7 @@
  */
 
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmRsaKeyGenParams
 ] dictionary RsaKeyGenParams : CryptoAlgorithmParameters {
     // The length, in bits, of the RSA modulus
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/RsaOaepParams.idl webkitgtk-2.48.0/Source/WebCore/crypto/parameters/RsaOaepParams.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/RsaOaepParams.idl	2025-02-25 02:25:41.003382200 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/parameters/RsaOaepParams.idl	2025-04-04 16:34:42.732673754 -0500
@@ -24,6 +24,7 @@
 */
 
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmRsaOaepParams
 ] dictionary RsaOaepParams : CryptoAlgorithmParameters {
     // The optional label/application data to associate with the message
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/RsaPssParams.idl webkitgtk-2.48.0/Source/WebCore/crypto/parameters/RsaPssParams.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/RsaPssParams.idl	2025-02-25 02:25:41.003382200 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/parameters/RsaPssParams.idl	2025-04-04 16:34:42.732837534 -0500
@@ -24,6 +24,7 @@
  */
 
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmRsaPssParams
 ] dictionary RsaPssParams : CryptoAlgorithmParameters {
     // The desired length of the random salt
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/X25519Params.idl webkitgtk-2.48.0/Source/WebCore/crypto/parameters/X25519Params.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/parameters/X25519Params.idl	2025-02-25 02:25:41.003382200 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/parameters/X25519Params.idl	2025-04-04 16:34:42.733029478 -0500
@@ -1,4 +1,5 @@
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmX25519Params,
 ] dictionary X25519Params : CryptoAlgorithmParameters {
     required CryptoKey publicKey;
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/RsaOtherPrimesInfo.idl webkitgtk-2.48.0/Source/WebCore/crypto/RsaOtherPrimesInfo.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/RsaOtherPrimesInfo.idl	2025-02-25 02:25:40.995382000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/RsaOtherPrimesInfo.idl	2025-04-04 16:34:42.733368670 -0500
@@ -24,6 +24,7 @@
  */
 
 [
+    Conditional=WEB_CRYPTO,
     JSGenerateToJSObject,
     JSGenerateToNativeObject
 ] dictionary RsaOtherPrimesInfo {
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/SerializedCryptoKeyWrap.h webkitgtk-2.48.0/Source/WebCore/crypto/SerializedCryptoKeyWrap.h
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/SerializedCryptoKeyWrap.h	2025-02-25 02:25:40.995382000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/SerializedCryptoKeyWrap.h	2025-04-04 16:34:42.733614605 -0500
@@ -28,6 +28,8 @@
 #include <wtf/Forward.h>
 #include <wtf/text/WTFString.h>
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 struct WrappedCryptoKey;
@@ -48,3 +50,5 @@ WEBCORE_EXPORT std::optional<WrappedCryp
 WEBCORE_EXPORT std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>& masterKey, const struct WrappedCryptoKey& wrappedKey);
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/SubtleCrypto.cpp webkitgtk-2.48.0/Source/WebCore/crypto/SubtleCrypto.cpp
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/SubtleCrypto.cpp	2025-02-25 02:25:40.995382000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/SubtleCrypto.cpp	2025-04-04 16:34:42.734253735 -0500
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "SubtleCrypto.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "ContextDestructionObserverInlines.h"
 #include "CryptoAlgorithm.h"
 #include "CryptoAlgorithmRegistry.h"
@@ -66,7 +68,7 @@ SubtleCrypto::SubtleCrypto(ScriptExecuti
 
 SubtleCrypto::~SubtleCrypto() = default;
 
-enum class Operations : uint8_t {
+enum class Operations {
     Encrypt,
     Decrypt,
     Sign,
@@ -1303,4 +1305,6 @@ void SubtleCrypto::unwrapKey(JSC::JSGlob
     unwrapAlgorithm->decrypt(*unwrapParams, unwrappingKey, WTFMove(wrappedKey), WTFMove(callback), WTFMove(exceptionCallback), *scriptExecutionContext(), m_workQueue);
 }
 
-} // namespace WebCore
+}
+
+#endif
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/SubtleCrypto.h webkitgtk-2.48.0/Source/WebCore/crypto/SubtleCrypto.h
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/SubtleCrypto.h	2025-02-25 02:25:40.995382000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/SubtleCrypto.h	2025-04-04 16:34:42.734410946 -0500
@@ -25,6 +25,8 @@
 
 #pragma once
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "ContextDestructionObserver.h"
 #include "CryptoKeyFormat.h"
 #include <JavaScriptCore/Strong.h>
@@ -84,4 +86,6 @@ private:
     HashMap<DeferredPromise*, Ref<DeferredPromise>> m_pendingPromises;
 };
 
-} // namespace WebCore
+}
+
+#endif
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/SubtleCrypto.idl webkitgtk-2.48.0/Source/WebCore/crypto/SubtleCrypto.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/crypto/SubtleCrypto.idl	2025-02-25 02:25:40.995382000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/crypto/SubtleCrypto.idl	2025-04-04 16:34:42.735198895 -0500
@@ -28,6 +28,7 @@ enum KeyFormat { "raw", "spki", "pkcs8",
 typedef (object or DOMString) AlgorithmIdentifier;
 
 [
+    Conditional=WEB_CRYPTO,
     Exposed=(Window,Worker),
     GenerateIsReachable=ImplScriptExecutionContext,
     SecureContext,
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/dom/Document.cpp webkitgtk-2.48.0/Source/WebCore/dom/Document.cpp
--- webkitgtk-2.48.0.epoxy/Source/WebCore/dom/Document.cpp	2025-02-25 02:25:41.075384000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/dom/Document.cpp	2025-04-04 16:34:42.737411001 -0500
@@ -9496,6 +9496,7 @@ void Document::didLoadResourceSynchronou
         page->cookieJar().clearCacheForHost(url.host().toString());
 }
 
+#if ENABLE(WEB_CRYPTO)
 std::optional<Vector<uint8_t>> Document::wrapCryptoKey(const Vector<uint8_t>& key)
 {
     RefPtr page = this->page();
@@ -9521,6 +9522,8 @@ std::optional<Vector<uint8_t>>Document::
     return page->cryptoClient().unwrapCryptoKey(wrappedKey);
 }
 
+#endif // ENABLE(WEB_CRYPTO)
+
 Element* Document::activeElement()
 {
     if (Element* element = treeScope().focusedElementInScope())
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/dom/Document.h webkitgtk-2.48.0/Source/WebCore/dom/Document.h
--- webkitgtk-2.48.0.epoxy/Source/WebCore/dom/Document.h	2025-02-25 02:25:41.079384000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/dom/Document.h	2025-04-04 16:34:42.739620184 -0500
@@ -1611,9 +1611,11 @@ public:
 
     void setVisualUpdatesAllowedByClient(bool);
 
+#if ENABLE(WEB_CRYPTO)
     std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>&) final;
     std::optional<Vector<uint8_t>> serializeAndWrapCryptoKey(CryptoKeyData&&) final;
     std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>&) final;
+#endif
 
     void setHasStyleWithViewportUnits() { m_hasStyleWithViewportUnits = true; }
     bool hasStyleWithViewportUnits() const { return m_hasStyleWithViewportUnits; }
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/dom/EmptyScriptExecutionContext.h webkitgtk-2.48.0/Source/WebCore/dom/EmptyScriptExecutionContext.h
--- webkitgtk-2.48.0.epoxy/Source/WebCore/dom/EmptyScriptExecutionContext.h	2025-02-25 02:25:41.083384000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/dom/EmptyScriptExecutionContext.h	2025-04-04 16:34:42.740454504 -0500
@@ -79,9 +79,11 @@ public:
     void postTask(Task&&) final { ASSERT_NOT_REACHED(); }
     EventTarget* errorEventTarget() final { return nullptr; };
 
+#if ENABLE(WEB_CRYPTO)
     std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>&) final { return std::nullopt; }
     std::optional<Vector<uint8_t>> serializeAndWrapCryptoKey(CryptoKeyData&&) final { return std::nullopt; }
     std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>&) final { return std::nullopt; }
+#endif
 
     JSC::VM& vm() final { return m_vm; }
     JSC::VM* vmIfExists() const final { return m_vm.ptr(); }
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/dom/ScriptExecutionContext.h webkitgtk-2.48.0/Source/WebCore/dom/ScriptExecutionContext.h
--- webkitgtk-2.48.0.epoxy/Source/WebCore/dom/ScriptExecutionContext.h	2025-02-25 02:25:41.103384500 -0600
+++ webkitgtk-2.48.0/Source/WebCore/dom/ScriptExecutionContext.h	2025-04-04 16:34:42.741103472 -0500
@@ -287,12 +287,14 @@ public:
     DatabaseContext* databaseContext() { return m_databaseContext.get(); }
     void setDatabaseContext(DatabaseContext*);
 
+#if ENABLE(WEB_CRYPTO)
     // These two methods are used when CryptoKeys are serialized into IndexedDB. As a side effect, it is also
     // used for things that utilize the same structure clone algorithm, for example, message passing between
     // worker and document.
     virtual std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>& key) = 0;
     virtual std::optional<Vector<uint8_t>> serializeAndWrapCryptoKey(CryptoKeyData&&) = 0;
     virtual std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>& wrappedKey) = 0;
+#endif
 
     int timerNestingLevel() const { return m_timerNestingLevel; }
     void setTimerNestingLevel(int timerNestingLevel) { m_timerNestingLevel = timerNestingLevel; }
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/page/Crypto.cpp webkitgtk-2.48.0/Source/WebCore/page/Crypto.cpp
--- webkitgtk-2.48.0.epoxy/Source/WebCore/page/Crypto.cpp	2025-02-25 02:25:41.275388700 -0600
+++ webkitgtk-2.48.0/Source/WebCore/page/Crypto.cpp	2025-04-04 16:34:42.741690103 -0500
@@ -46,7 +46,9 @@ namespace WebCore {
 
 Crypto::Crypto(ScriptExecutionContext* context)
     : ContextDestructionObserver(context)
+#if ENABLE(WEB_CRYPTO)
     , m_subtle(SubtleCrypto::create(context))
+#endif
 {
 }
 
@@ -72,9 +74,13 @@ String Crypto::randomUUID() const
     return createVersion4UUIDString();
 }
 
+#if ENABLE(WEB_CRYPTO)
+
 SubtleCrypto& Crypto::subtle()
 {
     return m_subtle;
 }
 
-} // namespace WebCore
+#endif
+
+}
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/page/Crypto.h webkitgtk-2.48.0/Source/WebCore/page/Crypto.h
--- webkitgtk-2.48.0.epoxy/Source/WebCore/page/Crypto.h	2025-02-25 02:25:41.275388700 -0600
+++ webkitgtk-2.48.0/Source/WebCore/page/Crypto.h	2025-04-04 16:34:42.742234413 -0500
@@ -48,12 +48,16 @@ public:
     ExceptionOr<void> getRandomValues(JSC::ArrayBufferView&);
     String randomUUID() const;
 
+#if ENABLE(WEB_CRYPTO)
     SubtleCrypto& subtle();
+#endif
 
 private:
     Crypto(ScriptExecutionContext*);
 
+#if ENABLE(WEB_CRYPTO)
     Ref<SubtleCrypto> m_subtle;
+#endif
 };
 
 }
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/page/Crypto.idl webkitgtk-2.48.0/Source/WebCore/page/Crypto.idl
--- webkitgtk-2.48.0.epoxy/Source/WebCore/page/Crypto.idl	2025-02-25 02:25:41.275388700 -0600
+++ webkitgtk-2.48.0/Source/WebCore/page/Crypto.idl	2025-04-04 16:34:42.742620063 -0500
@@ -31,7 +31,7 @@
     Exposed=(Window,Worker),
     GenerateIsReachable=ImplScriptExecutionContext
 ] interface Crypto {
-    [SecureContext] readonly attribute SubtleCrypto subtle;
+    [Conditional=WEB_CRYPTO, SecureContext] readonly attribute SubtleCrypto subtle;
     ArrayBufferView getRandomValues([ReturnValue] ArrayBufferView array);
     [SecureContext] DOMString randomUUID();
 };
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/PAL/pal/PlatformGTK.cmake webkitgtk-2.48.0/Source/WebCore/PAL/pal/PlatformGTK.cmake
--- webkitgtk-2.48.0.epoxy/Source/WebCore/PAL/pal/PlatformGTK.cmake	2025-02-25 02:25:40.831378000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/PAL/pal/PlatformGTK.cmake	2025-04-04 16:34:42.742863724 -0500
@@ -3,16 +3,12 @@ list(APPEND PAL_PUBLIC_HEADERS
     crypto/gcrypt/Initialization.h
     crypto/gcrypt/Utilities.h
 
-    crypto/tasn1/Utilities.h
-
     system/glib/SleepDisablerGLib.h
 )
 
 list(APPEND PAL_SOURCES
     crypto/gcrypt/CryptoDigestGCrypt.cpp
 
-    crypto/tasn1/Utilities.cpp
-
     system/ClockGeneric.cpp
 
     system/glib/SleepDisablerGLib.cpp
@@ -24,6 +20,16 @@ list(APPEND PAL_SOURCES
     unix/LoggingUnix.cpp
 )
 
+if (ENABLE_WEB_CRYPTO)
+    list(APPEND PAL_PUBLIC_HEADERS
+        crypto/tasn1/Utilities.h
+    )
+
+    list(APPEND PAL_SOURCES
+        crypto/tasn1/Utilities.cpp
+    )
+endif ()
+
 list(APPEND PAL_LIBRARIES
     GTK::GTK
 )
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/platform/GCrypt.cmake webkitgtk-2.48.0/Source/WebCore/platform/GCrypt.cmake
--- webkitgtk-2.48.0.epoxy/Source/WebCore/platform/GCrypt.cmake	2025-02-25 02:25:41.331390100 -0600
+++ webkitgtk-2.48.0/Source/WebCore/platform/GCrypt.cmake	2025-04-04 16:34:42.743210541 -0500
@@ -1,6 +1,8 @@
-list(APPEND WebCore_UNIFIED_SOURCE_LIST_FILES
-    "platform/SourcesGCrypt.txt"
-)
+if (ENABLE_WEB_CRYPTO)
+    list(APPEND WebCore_UNIFIED_SOURCE_LIST_FILES
+        "platform/SourcesGCrypt.txt"
+    )
+endif ()
 
 list(APPEND WebCore_LIBRARIES
     LibGcrypt::LibGcrypt
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/platform/LocalizedStrings.cpp webkitgtk-2.48.0/Source/WebCore/platform/LocalizedStrings.cpp
--- webkitgtk-2.48.0.epoxy/Source/WebCore/platform/LocalizedStrings.cpp	2025-02-25 02:25:41.335390000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/platform/LocalizedStrings.cpp	2025-04-04 16:34:42.743411110 -0500
@@ -1453,11 +1453,17 @@ String contextMenuItemTagShowMediaStats(
 
 #endif // ENABLE(VIDEO)
 
-#if PLATFORM(COCOA)
+#if ENABLE(WEB_CRYPTO) && PLATFORM(COCOA)
 
 String webCryptoMasterKeyKeychainLabel(const String& localizedApplicationName)
 {
+#if PLATFORM(COCOA)
     return WEB_UI_FORMAT_CFSTRING("%@ WebCrypto Master Key", "Name of application's single WebCrypto master key in Keychain", localizedApplicationName.createCFString().get());
+#elif USE(GLIB)
+    return WEB_UI_FORMAT_STRING("%s WebCrypto Master Key", "Name of application's single WebCrypto master key in Keychain", localizedApplicationName.utf8().data());
+#else
+    return makeStringByReplacingAll(WEB_UI_STRING("<application> WebCrypto Master Key", "Name of application's single WebCrypto master key in Keychain"), "<application>"_s, localizedApplicationName);
+#endif
 }
 
 String webCryptoMasterKeyKeychainComment()
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/platform/LocalizedStrings.h webkitgtk-2.48.0/Source/WebCore/platform/LocalizedStrings.h
--- webkitgtk-2.48.0.epoxy/Source/WebCore/platform/LocalizedStrings.h	2025-02-25 02:25:41.335390000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/platform/LocalizedStrings.h	2025-04-04 16:34:42.744593549 -0500
@@ -372,7 +372,7 @@ namespace WebCore {
     String contextMenuItemTagShowMediaStats();
 #endif // ENABLE(VIDEO)
 
-#if PLATFORM(COCOA)
+#if ENABLE(WEB_CRYPTO) && PLATFORM(COCOA)
     String webCryptoMasterKeyKeychainLabel(const String& localizedApplicationName);
     String webCryptoMasterKeyKeychainComment();
 #endif
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/platform/OpenSSL.cmake webkitgtk-2.48.0/Source/WebCore/platform/OpenSSL.cmake
--- webkitgtk-2.48.0.epoxy/Source/WebCore/platform/OpenSSL.cmake	2025-02-25 02:25:41.335390000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/platform/OpenSSL.cmake	2025-04-04 16:34:42.745117260 -0500
@@ -1,3 +1,4 @@
+if (ENABLE_WEB_CRYPTO)
 list(APPEND WebCore_SOURCES
     crypto/openssl/CryptoAlgorithmAESCBCOpenSSL.cpp
     crypto/openssl/CryptoAlgorithmAESCFBOpenSSL.cpp
@@ -18,3 +19,4 @@ list(APPEND WebCore_SOURCES
     crypto/openssl/OpenSSLUtilities.cpp
     crypto/openssl/SerializedCryptoKeyWrapOpenSSL.cpp
 )
+endif
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/workers/WorkerGlobalScope.cpp webkitgtk-2.48.0/Source/WebCore/workers/WorkerGlobalScope.cpp
--- webkitgtk-2.48.0.epoxy/Source/WebCore/workers/WorkerGlobalScope.cpp	2025-02-25 02:25:41.699399000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/workers/WorkerGlobalScope.cpp	2025-04-04 16:34:42.745727816 -0500
@@ -501,6 +501,7 @@ void WorkerGlobalScope::addMessage(Messa
     InspectorInstrumentation::addMessageToConsole(*this, WTFMove(message));
 }
 
+#if ENABLE(WEB_CRYPTO)
 std::optional<Vector<uint8_t>> WorkerGlobalScope::wrapCryptoKey(const Vector<uint8_t>& key)
 {
     Ref protectedThis { *this };
@@ -552,6 +553,8 @@ std::optional<Vector<uint8_t>> WorkerGlo
     return key;
 }
 
+#endif // ENABLE(WEB_CRYPTO)
+
 Crypto& WorkerGlobalScope::crypto()
 {
     if (!m_crypto)
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/workers/WorkerGlobalScope.h webkitgtk-2.48.0/Source/WebCore/workers/WorkerGlobalScope.h
--- webkitgtk-2.48.0.epoxy/Source/WebCore/workers/WorkerGlobalScope.h	2025-02-25 02:25:41.699399000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/workers/WorkerGlobalScope.h	2025-04-04 16:34:42.746401171 -0500
@@ -208,9 +208,11 @@ private:
 
     bool shouldBypassMainWorldContentSecurityPolicy() const final { return m_shouldBypassMainWorldContentSecurityPolicy; }
 
+#if ENABLE(WEB_CRYPTO)
     std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>& key) final;
     std::optional<Vector<uint8_t>> serializeAndWrapCryptoKey(CryptoKeyData&&) final;
     std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>& wrappedKey) final;
+#endif
 
     // ReportingClient.
     void notifyReportObservers(Ref<Report>&&) final;
diff -urp webkitgtk-2.48.0.epoxy/Source/WebCore/worklets/WorkletGlobalScope.h webkitgtk-2.48.0/Source/WebCore/worklets/WorkletGlobalScope.h
--- webkitgtk-2.48.0.epoxy/Source/WebCore/worklets/WorkletGlobalScope.h	2025-02-25 02:25:41.711399000 -0600
+++ webkitgtk-2.48.0/Source/WebCore/worklets/WorkletGlobalScope.h	2025-04-04 16:34:42.746964868 -0500
@@ -105,9 +105,11 @@ private:
 
     EventTarget* errorEventTarget() final { return this; }
 
+#if ENABLE(WEB_CRYPTO)
     std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>&) final { RELEASE_ASSERT_NOT_REACHED(); return std::nullopt; }
     std::optional<Vector<uint8_t>> serializeAndWrapCryptoKey(CryptoKeyData&&) final { RELEASE_ASSERT_NOT_REACHED(); return std::nullopt; }
     std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>&) final { RELEASE_ASSERT_NOT_REACHED(); return std::nullopt; }
+#endif
     URL completeURL(const String&, ForceUTF8 = ForceUTF8::No) const final;
     String userAgent(const URL&) const final;
     const Settings::Values& settingsValues() const final { return m_settingsValues; }
diff -urp webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/API/C/WKPage.cpp webkitgtk-2.48.0/Source/WebKit/UIProcess/API/C/WKPage.cpp
--- webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/API/C/WKPage.cpp	2025-02-25 02:25:42.003406300 -0600
+++ webkitgtk-2.48.0/Source/WebKit/UIProcess/API/C/WKPage.cpp	2025-04-04 16:34:42.747411183 -0500
@@ -2466,6 +2466,7 @@ void WKPageSetPageNavigationClient(WKPag
             return false;
         }
 
+#if ENABLE(WEB_CRYPTO)
         void legacyWebCryptoMasterKey(WebKit::WebPageProxy& page, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&& completionHandler) override
         {
             if (m_client.copyWebCryptoMasterKey) {
@@ -2474,6 +2475,7 @@ void WKPageSetPageNavigationClient(WKPag
             }
             return completionHandler(defaultWebCryptoMasterKey());
         }
+#endif
 
         void navigationActionDidBecomeDownload(WebKit::WebPageProxy& page, API::NavigationAction& action, WebKit::DownloadProxy& download) override
         {
diff -urp webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebPageProxy.cpp webkitgtk-2.48.0/Source/WebKit/UIProcess/WebPageProxy.cpp
--- webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebPageProxy.cpp	2025-03-17 16:18:47.856950994 -0500
+++ webkitgtk-2.48.0/Source/WebKit/UIProcess/WebPageProxy.cpp	2025-04-04 16:34:42.751411256 -0500
@@ -13252,6 +13252,7 @@ void WebPageProxy::getWebCryptoMasterKey
 
 }
 
+#if ENABLE(WEB_CRYPTO)
 void WebPageProxy::wrapCryptoKey(Vector<uint8_t>&& key, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&& completionHandler)
 {
     getWebCryptoMasterKey([key = WTFMove(key), completionHandler = WTFMove(completionHandler)](std::optional<Vector<uint8_t>> && masterKey) mutable {
@@ -13290,6 +13291,7 @@ void WebPageProxy::unwrapCryptoKey(Wrapp
     });
 
 }
+#endif
 
 void WebPageProxy::changeFontAttributes(WebCore::FontAttributeChanges&& changes)
 {
diff -urp webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebPageProxy.h webkitgtk-2.48.0/Source/WebKit/UIProcess/WebPageProxy.h
--- webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebPageProxy.h	2025-03-17 16:58:05.965821579 -0500
+++ webkitgtk-2.48.0/Source/WebKit/UIProcess/WebPageProxy.h	2025-04-04 16:34:42.753411292 -0500
@@ -1906,9 +1906,11 @@ public:
     RefPtr<ViewSnapshot> takeViewSnapshot(std::optional<WebCore::IntRect>&&, ForceSoftwareCapturingViewportSnapshot);
 #endif
 
+#if ENABLE(WEB_CRYPTO)
     void wrapCryptoKey(Vector<uint8_t>&&, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&&);
     void serializeAndWrapCryptoKey(IPC::Connection&, WebCore::CryptoKeyData&&, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&&);
     void unwrapCryptoKey(WebCore::WrappedCryptoKey&&, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&&);
+#endif
 
     void takeSnapshot(WebCore::IntRect, WebCore::IntSize bitmapSize, SnapshotOptions, CompletionHandler<void(std::optional<WebCore::ShareableBitmapHandle>&&)>&&);
 
diff -urp webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebPageProxy.messages.in webkitgtk-2.48.0/Source/WebKit/UIProcess/WebPageProxy.messages.in
--- webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebPageProxy.messages.in	2025-03-17 16:18:47.860994175 -0500
+++ webkitgtk-2.48.0/Source/WebKit/UIProcess/WebPageProxy.messages.in	2025-04-04 16:34:42.755273947 -0500
@@ -445,9 +445,11 @@ messages -> WebPageProxy {
 
     DidUpdateActivityState() CanDispatchOutOfOrder
 
+#if ENABLE(WEB_CRYPTO)
     WrapCryptoKey(Vector<uint8_t> key) -> (std::optional<Vector<uint8_t>> wrappedKey) Synchronous
     SerializeAndWrapCryptoKey(struct WebCore::CryptoKeyData key) -> (std::optional<Vector<uint8_t>> wrappedKey) Synchronous
     UnwrapCryptoKey(struct WebCore::WrappedCryptoKey wrappedKey) -> (std::optional<Vector<uint8_t>> key) Synchronous
+#endif
 
 
 #if ENABLE(TELEPHONE_NUMBER_DETECTION)
diff -urp webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebProcessProxy.cpp webkitgtk-2.48.0/Source/WebKit/UIProcess/WebProcessProxy.cpp
--- webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebProcessProxy.cpp	2025-02-25 02:25:42.123409000 -0600
+++ webkitgtk-2.48.0/Source/WebKit/UIProcess/WebProcessProxy.cpp	2025-04-04 16:34:42.755411329 -0500
@@ -2812,6 +2812,7 @@ void WebProcessProxy::getNotifications(c
     WebNotificationManagerProxy::serviceWorkerManagerSingleton().getNotifications(registrationURL, tag, sessionID(), WTFMove(callback));
 }
 
+#if ENABLE(WEB_CRYPTO)
 void WebProcessProxy::getWebCryptoMasterKey(CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&& completionHandler)
 {
     m_websiteDataStore->client().webCryptoMasterKey([completionHandler = WTFMove(completionHandler)](std::optional<Vector<uint8_t>>&& key) mutable {
@@ -2820,7 +2821,9 @@ void WebProcessProxy::getWebCryptoMaster
         return completionHandler(WebCore::defaultWebCryptoMasterKey());
     });
 }
+#endif
 
+#if ENABLE(WEB_CRYPTO)
 void WebProcessProxy::wrapCryptoKey(Vector<uint8_t>&& key, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&& completionHandler)
 {
     getWebCryptoMasterKey([key = WTFMove(key), completionHandler = WTFMove(completionHandler)](std::optional<Vector<uint8_t>> && masterKey) mutable {
@@ -2857,8 +2860,9 @@ void WebProcessProxy::unwrapCryptoKey(Wr
             return completionHandler(WTFMove(key));
         completionHandler(std::nullopt);
     });
-
 }
+#endif
+
 void WebProcessProxy::setAppBadge(std::optional<WebPageProxyIdentifier> pageIdentifier, const SecurityOriginData& origin, std::optional<uint64_t> badge)
 {
     if (!pageIdentifier) {
diff -urp webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebProcessProxy.h webkitgtk-2.48.0/Source/WebKit/UIProcess/WebProcessProxy.h
--- webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebProcessProxy.h	2025-02-25 02:25:42.123409000 -0600
+++ webkitgtk-2.48.0/Source/WebKit/UIProcess/WebProcessProxy.h	2025-04-04 16:34:42.757388751 -0500
@@ -582,7 +582,9 @@ private:
 
     void validateFreezerStatus();
 
+#if ENABLE(WEB_CRYPTO)
     void getWebCryptoMasterKey(CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&&);
+#endif
     using WebProcessProxyMap = HashMap<WebCore::ProcessIdentifier, CheckedRef<WebProcessProxy>>;
     static WebProcessProxyMap& allProcessMap();
     static Vector<Ref<WebProcessProxy>> allProcesses();
diff -urp webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebProcessProxy.messages.in webkitgtk-2.48.0/Source/WebKit/UIProcess/WebProcessProxy.messages.in
--- webkitgtk-2.48.0.epoxy/Source/WebKit/UIProcess/WebProcessProxy.messages.in	2025-02-25 02:25:42.123409000 -0600
+++ webkitgtk-2.48.0/Source/WebKit/UIProcess/WebProcessProxy.messages.in	2025-04-04 16:34:42.757968248 -0500
@@ -93,9 +93,11 @@ messages -> WebProcessProxy WantsDispatc
     [EnabledBy=AppBadgeEnabled] SetAppBadge(std::optional<WebKit::WebPageProxyIdentifier> pageIdentifier, WebCore::SecurityOriginData origin, std::optional<uint64_t> badge)
     [EnabledBy=AppBadgeEnabled] SetClientBadge(WebKit::WebPageProxyIdentifier pageIdentifier, WebCore::SecurityOriginData origin, std::optional<uint64_t> badge)
 
+#if ENABLE(WEB_CRYPTO)
     WrapCryptoKey(Vector<uint8_t> key) -> (std::optional<Vector<uint8_t>> wrappedKey) Synchronous
     SerializeAndWrapCryptoKey(struct WebCore::CryptoKeyData key) -> (std::optional<Vector<uint8_t>> wrappedKey) Synchronous
     UnwrapCryptoKey(struct WebCore::WrappedCryptoKey wrappedKey) -> (std::optional<Vector<uint8_t>> key) Synchronous
+#endif
 
 #if ENABLE(LOGD_BLOCKING_IN_WEBCONTENT)
     SetupLogStream(uint32_t pid, IPC::StreamServerConnectionHandle serverConnection, WebKit::LogStreamIdentifier identifier) -> (IPC::Semaphore streamWakeUpSemaphore, IPC::Semaphore streamClientWaitSemaphore)
diff -urp webkitgtk-2.48.0.epoxy/Source/WebKit/WebProcess/WebCoreSupport/WebCryptoClient.cpp webkitgtk-2.48.0/Source/WebKit/WebProcess/WebCoreSupport/WebCryptoClient.cpp
--- webkitgtk-2.48.0.epoxy/Source/WebKit/WebProcess/WebCoreSupport/WebCryptoClient.cpp	2025-02-25 02:25:42.231411700 -0600
+++ webkitgtk-2.48.0/Source/WebKit/WebProcess/WebCoreSupport/WebCryptoClient.cpp	2025-04-04 16:34:42.758491749 -0500
@@ -38,6 +38,7 @@ namespace WebKit {
 
 WTF_MAKE_TZONE_ALLOCATED_IMPL(WebCryptoClient);
 
+#if ENABLE(WEB_CRYPTO)
 std::optional<Vector<uint8_t>> WebCryptoClient::wrapCryptoKey(const Vector<uint8_t>& key) const
 {
     if (m_pageIdentifier) {
@@ -80,6 +81,7 @@ std::optional<Vector<uint8_t>> WebCrypto
     auto [unwrappedKey] = sendResult.takeReplyOr(std::nullopt);
     return unwrappedKey;
 }
+#endif
 
 WebCryptoClient::WebCryptoClient(WebCore::PageIdentifier pageIdentifier)
     : m_pageIdentifier(pageIdentifier)
